drill_hole = 3.5;
drill_hole_circle = 25;
bearing_hole = 15.3;
bearing_hole_pos = drill_hole_circle / 2 + 5;

wall_thickness = 5;
wall_height = 20;

width = 35;
length = 130;
thickness = 5;

box_length = 40;

socket_width = 20;
socket_height = 20;
socket_cut = 2;
socket_hole = 8;
socket_drill_hole = 4.4;
socket_inwards = 10;

linkage_length = 40;
linkage_hole_edge = 5;
center_length = 400 - (length - bearing_hole_pos) * 2;

bar_width = 19.0;
bar_pos = 88 + 7.5 - socket_inwards;
extra_length = 30;

hole_distance_w = 7 + bar_width / 2;
hole_distance_l = 20;

clamp_length = width - 1;
clamp_width = hole_distance_w + 25;
clamp_height = 10;


translate([50, 0, 0]){
  BearingPart();
}
translate([0, 0, 0]){
  BearingPart();
}
/*
translate([-50, -10, 0]){
  CenterPart();
}
*/
translate([86, 50, 0]){
 BarSocket();
}
translate([-46, 62, 0]){
 BarSocket();
}
translate([-46, 0, 0]){
 BarSocket();
}
translate([-46, -62, 0]){
 BarSocket();
}


translate([97, -60, 0]){
  ClampsPrintBed();
}
translate([97, -10, 0]){
  ClampsPrintBed();
}

translate([26, -80, 0]){
  rotate([0, 0, 90]){
    SwitchMount();
  }
}


/*
translate([-55, 179, 0]){
  rotate([0, 0, 90]){
    BarSocketAsymetric();
  }
}

translate([-5, 179, 0]){
  mirror([1,0,0]){
    rotate([0, 0, 90]){
      BarSocketAsymetric();
    }
  }
}

/*
cube(size = [15, 223, 15], center = true);

translate([-27, (223+88)/2, 0]){
  cube(size = [15, 88, 15], center = true);
}

rotate([0, 0, 180]){
  translate([0, length/2 + center_length / 2, 0]){
    BearingPart();
  }
}
translate([0, length/2 + center_length / 2, 0]){
  BearingPart();
}
translate([-0, -0, 10]){
  CenterPart();
}

translate([50, 20, 0]){
 BarSocket();
}
*/

//New mount Z axis switch
module SwitchMount(){
  translate([0, 0, 5]){
    cube(size = [20, 100, 10], center = true);
    translate([10 - wall_thickness/2, -50 + wall_thickness, 0]){
      linear_extrude(height = 30, scale=[1, 0]){
        translate([0, 10, 0]){
          square(size = [wall_thickness, 30], center = true);
        }
      }
    }
    translate([-10 + wall_thickness/2, -50 + wall_thickness, 0]){
      linear_extrude(height = 30, scale=[1, 0]){
        translate([0, 10, 0]){
          square(size = [wall_thickness, 30], center = true);
        }
      }
    }
    translate([0, -50 + wall_thickness/2, 15]){
      difference(){
        cube(size = [20, wall_thickness, 30], center = true);
        rotate([90, 0, 0]){
          cylinder($fn = 200, h = socket_height * 10.1, r = socket_drill_hole / 2, center = true);
        }
      }
    }
  }
}

//socket for round bar
module BarSocket(){
  translate([0, 0, socket_height / 2]){
    translate([socket_inwards/2, 0, 0]){
      difference(){
        cube(size = [socket_width + socket_inwards, socket_width, socket_height], center = true);
        translate([socket_inwards/2, 0, 0]){
          cylinder($fn = 200, h = socket_height * 1.1, r = socket_hole / 2, center = true);
          translate([socket_width / 2, 0, 0]){
            cube(size = [socket_width, socket_cut, socket_height * 1.1], center = true);
          }
        }
      }
    }
    translate([0, 0, -(socket_height - wall_thickness) / 2]){
      difference(){
        cube(size = [socket_width, socket_width * 2, wall_thickness], center = true);
        translate([socket_inwards, 0, 0]){
          cylinder($fn = 200, h = socket_height * 1.1, r = socket_hole / 2, center = true);
        }
        translate([socket_width / 2, 0, 0]){
          cube(size = [socket_width, socket_cut, socket_height * 1.1], center = true);
        }
        translate([0, socket_width, 0]){
          cylinder($fn = 200, h = wall_thickness * 1.1, r = socket_drill_hole / 2, center = true);
        }
        translate([0, -socket_width, 0]){
          cylinder($fn = 200, h = wall_thickness * 1.1, r = socket_drill_hole / 2, center = true);
        }
      }
      translate([0, -socket_width, 0]){
        difference(){
          cylinder($fn = 200, h = wall_thickness, r = socket_width / 2, center = true);
          cylinder($fn = 200, h = wall_thickness * 1.1, r = socket_drill_hole / 2, center = true);
        }
      }
      translate([0,   socket_width, 0]){
        difference(){
          cylinder($fn = 200, h = wall_thickness, r = socket_width / 2, center = true);
          cylinder($fn = 200, h = wall_thickness * 1.1, r = socket_drill_hole / 2, center = true);
        }
      }
    }
  }
}

//socket for round bar asymetric style
module BarSocketAsymetric(){
  translate([0, 0, socket_height / 2]){
    translate([socket_width * 0.75, (wall_thickness + socket_cut) / 2, 0]){
      difference(){
        cube(size = [socket_width*0.5, wall_thickness, socket_height], center = true);
        rotate([90, 0, 0]){
          cylinder($fn = 200, h = socket_height * 1.1, r = drill_hole / 2, center = true);
        }
      }
    }
    translate([socket_width * 0.75, -(wall_thickness + socket_cut) / 2, 0]){
      difference(){
        cube(size = [socket_width*0.5, wall_thickness, socket_height], center = true);
        rotate([90, 0, 0]){
          cylinder($fn = 200, h = socket_height * 1.1, r = drill_hole / 2, center = true);
        }
      }
    }
    difference(){
      cube(size = [socket_width, socket_width, socket_height], center = true);
      cylinder($fn = 200, h = socket_height * 1.1, r = socket_hole / 2, center = true);
      translate([socket_width / 2, 0, 0]){
        cube(size = [socket_width, socket_cut, socket_height * 1.1], center = true);
      }
    }
    translate([0, 0, -(socket_height - wall_thickness) / 2]){
      difference(){
        translate([0, socket_width/2, 0]){
          cube(size = [socket_width, socket_width * 2, wall_thickness], center = true);
        }
        cylinder($fn = 200, h = socket_height * 1.1, r = socket_hole / 2, center = true);
        translate([socket_width / 2, 0, 0]){
          cube(size = [socket_width, socket_cut, socket_height * 1.1], center = true);
        }
        translate([0, socket_width*1.5, 0]){
          cylinder($fn = 200, h = wall_thickness * 1.1, r = socket_drill_hole / 2, center = true);
        }
        translate([0, socket_width * 0.8, 0]){
          cylinder($fn = 200, h = wall_thickness * 1.1, r = socket_drill_hole / 2, center = true);
        }
      }
      translate([0,   socket_width*1.5, 0]){
        difference(){
          cylinder($fn = 200, h = wall_thickness, r = socket_width / 2, center = true);
          cylinder($fn = 200, h = wall_thickness * 1.1, r = socket_drill_hole / 2, center = true);
        }
      }
    }
  }
  translate([(socket_width - wall_thickness)/2, socket_cut/2, thickness]){
    linear_extrude(height=socket_height - thickness, scale=[1, 0.3]){
      translate([0, socket_width * 0.75, 0]){
        square(size = [wall_thickness, socket_width * 1.5], center = true);
      }
    }
  }
  translate([-(socket_width - wall_thickness)/2, socket_cut/2, thickness]){
    linear_extrude(height=socket_height - thickness, scale=[1, 0.3]){
      translate([0, socket_width * 0.75, 0]){
        square(size = [wall_thickness, socket_width * 1.5], center = true);
      }
    }
  }
}

//Clamps for print bed
module ClampsPrintBed(){
  translate([ 0, 0, clamp_height / 2]){
    difference(){
      cube(size = [clamp_length, clamp_width, clamp_height], center = true);
      translate([0, 0, bar_width * 0.6]){
        cube(size = [clamp_length * 1.1, bar_width, bar_width], center = true);
      }
       translate([hole_distance_l / 2, - hole_distance_w, 0]){
         cylinder($fn = 200, h = clamp_height * 1.1, r = drill_hole / 2, center = true);
       }
       translate([-hole_distance_l / 2, - hole_distance_w, 0]){
         cylinder($fn = 200, h = clamp_height * 1.1, r = drill_hole / 2, center = true);
       }
       translate([-hole_distance_l / 2,  hole_distance_w, 0]){
         cylinder($fn = 200, h = clamp_height * 1.1, r = drill_hole / 2, center = true);
       }
       translate([hole_distance_l / 2,  hole_distance_w, 0]){
         cylinder($fn = 200, h = clamp_height * 1.1, r = drill_hole / 2, center = true);
       }
     
    }
  }
}


//center part  
module CenterPart(){
  translate([-0, 0, thickness / 2]){
    cube(size = [width, center_length, thickness], center = true);    
  }
  translate([(wall_thickness + width) / 2, 0, wall_height / 2]){
    cube(size = [wall_thickness, center_length, wall_height], center = true);    
  }
  translate([-(wall_thickness + width) / 2, 0, wall_height / 2]){
    cube(size = [wall_thickness, center_length, wall_height], center = true);    
  }

  difference(){
    translate([0, center_length / 2, wall_height / 2]){
      cube(size = [width, linkage_length * 2, wall_height], center = true);    
    }
    translate([0, center_length / 2 + linkage_hole_edge, wall_height / 2]){
      rotate([0, 90, 0]){
        cylinder($fn = 200, h = wall_thickness * 10.1, r = drill_hole / 2, center = true);   
      }
    }
    translate([0, center_length / 2 + linkage_length - linkage_hole_edge, wall_height / 2]){
      rotate([0, 90, 0]){
        cylinder($fn = 200, h = wall_thickness * 10.1, r = drill_hole / 2, center = true);   
      }
    }
  }

  difference(){
    translate([0, -center_length / 2, wall_height / 2]){
      cube(size = [width, linkage_length * 2, wall_height], center = true);    
    }
    translate([0, -center_length / 2 - linkage_hole_edge, wall_height / 2]){
      rotate([0, 90, 0]){
        cylinder($fn = 200, h = wall_thickness * 10.1, r = drill_hole / 2, center = true);   
      }
    }
    translate([0, -(center_length / 2 + linkage_length - linkage_hole_edge), wall_height / 2]){
      rotate([0, 90, 0]){
        cylinder($fn = 200, h = wall_thickness * 10.1, r = drill_hole / 2, center = true);   
      }
    }
  }
  
}


//bar with bearing
module BearingPart(){
  translate([0, length / 2 - bearing_hole_pos - (bar_pos)/2 - (15-bar_width), wall_height / 2]){
    cube(size = [width, box_length, wall_height], center = true);    
  }
  
  difference(){
    translate([(wall_thickness + width) / 2, 0, wall_height / 2]){
      cube(size = [wall_thickness, length, wall_height], center = true);    
    }
    translate([0, -(bar_pos - length / 2 + bearing_hole_pos), bar_width + thickness]){
      cube(size = [(width + wall_thickness * 2) * 1.1, bar_width, bar_width * 2], center = true);    
    }
  }

  difference(){
    translate([-(wall_thickness + width) / 2, 0, wall_height / 2]){
      cube(size = [wall_thickness, length, wall_height], center = true);    
    }
    translate([0, -(bar_pos - length / 2 + bearing_hole_pos), bar_width + thickness]){
      cube(size = [(width + wall_thickness * 2) * 1.1, bar_width, bar_width * 2], center = true);    
    }
  }

  translate([0, 0, thickness / 2]){
    difference(){
      cube(size = [width, length, thickness], center = true);    

    translate([hole_distance_l / 2, -(bar_pos - length / 2 + bearing_hole_pos) + hole_distance_w, 0]){
      cylinder($fn = 200, h = thickness * 1.1, r = drill_hole / 2, center = true);    
    }
    translate([-hole_distance_l / 2, -(bar_pos - length / 2 + bearing_hole_pos) + hole_distance_w, 0]){
      cylinder($fn = 200, h = thickness * 1.1, r = drill_hole / 2, center = true);    
    }
    translate([hole_distance_l / 2, -(bar_pos - length / 2 + bearing_hole_pos) - hole_distance_w, 0]){
      cylinder($fn = 200, h = thickness * 1.1, r = drill_hole / 2, center = true);    
    }
    translate([-hole_distance_l / 2, -(bar_pos - length / 2 + bearing_hole_pos) - hole_distance_w, 0]){
      cylinder($fn = 200, h = thickness * 1.1, r = drill_hole / 2, center = true);    
    }

      translate([0, length / 2 - bearing_hole_pos, 0]){      
        cylinder($fn = 200, h = thickness * 1.1, r = bearing_hole / 2, center = true);
        for (i=[0:90:360]){
          rotate([0, 0, i + 45]){
            translate([0, drill_hole_circle / 2, 0]){
              cylinder($fn = 200, h = thickness * 1.1, r = drill_hole / 2, center = true);
            }
          }
        }
        
      }
    }
  }
}

